
#ifndef __OLED_H__
#define __OLED_H__

#define NORMAL(x0, x1)      NormalXY(&##x0, &##x1)

void NormalXY(int *x0, int *x1);

void OLED_WR_CMD(uint8_t *cmd, uint16_t len);
void OLED_WR_DAT(uint8_t *dat, uint16_t len);

void OLED_Init(void);
void OLED_DisplayOn(void);
void OLED_DisplayOff(void);
void OLED_Refresh(void);

void OLED_ClearScreen(uint8_t rf);
void OLED_Char6x8(int x, int y, char c);
void OLED_Char8x16(int x, int y, char c);
void OLED_Char16x16(int x, int y, char hz[2]);

void OLED_ShowBMP(int x, int y, int w, int h, uint8_t *bmp, uint8_t rf);
void OLED_DrawString(int x, int y, char *str, uint8_t rf);
void OLED_DrawPoint(int x, int y, uint8_t rf);
void OLED_DrawLine(int x0, int y0, int x1, int y1, uint8_t rf);
void OLED_DrawBox(int x0, int y0, int x1, int y1, uint8_t rf);
void OLED_DrawCircle(int x0, int y0, int r, uint8_t rf);
void OLED_FillBox(int x0, int y0, int x1, int y1, uint8_t rf);
void OLED_FillCircle(int x0, int y0, int r, uint8_t rf);

void OLED_ReverseMode();
void OLED_NormalMode();
void OLED_SetFontHeight(uint8_t h);

#endif
