////////////////////////////////////////
// ļ: oled.c
// ļ: 
// ļ汾: V1.0
// ޸ļ¼:
//   1. (2025-06-09) ļ
////////////////////////////////////////


#include "config.h"


BOOL fReverseMode;                      //ʾģʽ (0:ʾ; 1:ʾ;)
uint8_t FontHeight;                     //ʾĸ߶ (8:6*8; 16:8*16;)

uint8_t OledCache[1024];	        //OLEDʾ


////////////////////////////////////////
// OLEDʼ
// ڲ: 
// : 
////////////////////////////////////////
void OLED_Init(void)
{
    static uint8_t code INIT_SEQU[] = 
    {
        0xAE,                   //--turn off oled panel
        0x00,                   //--set low column address
        0x10,                   //--set high column address
        0x40,                   //--set start line address  Set Mapping RAM Display Start Line (0x00~0x3F)
        0x81,                   //--set contrast control register
        0xCF,                   //--Set SEG Output Current Brightness ... 
        0xA1,                   //--Set SEG/Column Mapping     0xA0ҷת 0xA1
        0xC8,                   //--Set COM/Row Scan Direction 0xC0·ת 0xC8
        0xA6,                   //--set normal display
        0xA8,                   //--set multiplex ratio(1 to 64)
        0x3f,                   //--1/64 duty
        0xD3,                   //--set display offset	Shift Mapping RAM Counter (0x00~0x3F)
        0x00,                   //--not ofset
        0xd5,                   //--set display clock divide ratio/oscillator frequency
        0x80,                   //--set divide ratio, Set Clock as 100 Frames/Sec
        0xD9,                   //--set pre-charge period
        0xF1,                   //--Set Pre-Charge as 15 Clocks & Discharge as 1 Clock
        0xDA,                   //--set com pins hardware configuration
        0x12,                  
        0xDB,                   //--set vcomh
        0x40,                   //--Set VCOM Deselect Level
        0x20,                   //--Set Page Addressing Mode (0x00/0x01/0x02)
        0x00,                   //
        0x8D,                   //--set Charge Pump enable/disable
        0x14,                   //--set(0x10) disable
        0xA4,                   //--Disable Entire Display On (0xa4/0xa5)
        0xA6,                   //--Disable Inverse Display On (0xa6/a7) 
        0xAF,                   //--turn on oled panel
    };
    OLED_NormalMode();                  //ʾģʽΪģʽ
    OLED_SetFontHeight(16);             //ĬʾΪ8*16

    OLED_WR_CMD(INIT_SEQU, sizeof(INIT_SEQU)); //ͳʼ

    OLED_DisplayOn();                   //ʾ
    OLED_ClearScreen(1);                //
}

////////////////////////////////////////
// OLEDʾ
// ڲ: 
// : 
////////////////////////////////////////
void OLED_DisplayOn(void)
{
    uint8_t cmd[3];
    
    cmd[0] = 0x8D;                      //ɱʹ
    cmd[1] = 0x14;                      //ɱ
    cmd[2] = 0xAF;                      //Ļ
    OLED_WR_CMD(cmd, 3);  
}

////////////////////////////////////////
// رOLEDʾ
// ڲ: 
// : 
////////////////////////////////////////
void OLED_DisplayOff(void)
{
    uint8_t cmd[3];
    
    cmd[0] = 0x8D;                      //ɱʹ
    cmd[1] = 0x10;                      //رյɱ
    cmd[2] = 0xAF;                      //رĻ        
    OLED_WR_CMD(cmd, 3);  
}

////////////////////////////////////////
// ˢOLEDʾ
// ڲ: 
// : 
////////////////////////////////////////
void OLED_Refresh(void)
{
    uint8_t cmd[3];
    
    cmd[0] = 0x40;                      //ʼַ
    cmd[1] = 0x00;                      //õʼַ
    cmd[2] = 0x10;                      //øʼַ
    OLED_WR_CMD(cmd, 3);  
    OLED_WR_DAT(OledCache, 1024);       //д...
}

////////////////////////////////////////
// OLEDʾ
// ڲ: 
// : 
////////////////////////////////////////
void OLED_ReverseMode()
{
    fReverseMode = 1;                   //ʾģʽΪģʽ
}

////////////////////////////////////////
// OLEDʾ
// ڲ: 
// : 
////////////////////////////////////////
void OLED_NormalMode()
{
    fReverseMode = 0;                   //ʾģʽΪģʽ
}

////////////////////////////////////////
// OLEDʾ
// ڲ: 
// : 
////////////////////////////////////////
void OLED_SetFontHeight(uint8_t h)
{
    if (h == 8)
        FontHeight = 8;
    else
        FontHeight = 16;
}

////////////////////////////////////////
// OLED
// ڲ: 
// : 
////////////////////////////////////////
void OLED_ClearScreen(uint8_t rf)
{
    if (fReverseMode)
        memset(OledCache, 0xff, 1024);
    else
        memset(OledCache, 0, 1024);

    if (rf)
        OLED_Refresh();                 //ˢʾ
}

////////////////////////////////////////
// ʾ128*64СBMPͼƬ
// ڲ: x (ˮƽ 0~127)
//           y (ֱ 0~7)
//           w (ͼƬ)
//           y (ͼƬ߶)
//           bmp (ͼƬʼַ)
// : 
////////////////////////////////////////
void OLED_ShowBMP(int x, int y, int w, int h, uint8_t *bmp, uint8_t rf)
{
    int i, j;
    uint8_t dat;
    
    for (j = 0; j < h; j++)
    {
        for (i = 0; i < w; i++)
        {
            dat = *bmp++;               //ȡͼƬ
            if (fReverseMode)           //ʾȡ
                dat = ~dat;

            OledCache[(y+j) * 128 + (x+i)] = dat;
        }
    }

    if (rf)
        OLED_Refresh();                 //ˢʾ
}

////////////////////////////////////////
// ʾ6*8СַASCII룩
// ڲ: x (ˮƽ 0~127)
//           y (ֱ 0~7)
//           c (ʾַASCII)
// : 
////////////////////////////////////////
void OLED_Char6x8(int x, int y, char c)
{
    int i;
    uint8_t dat;
    
    for (i = 0; i < 6; i++)
    {
        dat = ASCII_6x8[c - ' '][i];
        if (fReverseMode)           //ʾȡ
            dat = ~dat;
        
        OledCache[y * 128 + (x+i)] = dat;
    }
}

////////////////////////////////////////
// ʾ8*16СַASCII룩
// ڲ: x (ˮƽ 0~127)
//           y (ֱ 0~7)
//           c (ʾַASCII)
// : 
////////////////////////////////////////
void OLED_Char8x16(int x, int y, char c)
{
    int i, j;
    uint8_t dat;
    
    for (j = 0; j < 2; j++)
    {
        for (i = 0; i < 8; i++)
        {
            dat = ASCII_8x16[c - ' '][i + j * 8];
            if (fReverseMode)           //ʾȡ
                dat = ~dat;
            
            OledCache[(y+j) * 128 + (x+i)] = dat;
        }
    }
}

////////////////////////////////////////
// ʾ16*16Сַ֣
// ڲ: x (ˮƽ 0~127)
//           y (ֱ 0~7)
//           hz (ֵGB2312)
// : 
////////////////////////////////////////
void OLED_Char16x16(int x, int y, char hz[2])
{
    int i, j;
    uint8_t dat;
    struct FONT_DATA *p;
    
    p = NULL;
    for (i = 0; Font_Data[i].txt[0]; i++)
    {
        if ((Font_Data[i].txt[0] == hz[0]) &&
            (Font_Data[i].txt[1] == hz[1]))
        {
            p = &Font_Data[i];
            break;
        }
    }
    
    if (p != NULL)
    {
        for (j = 0; j < 2; j++)
        {
            for (i = 0; i < 16; i++)
            {
                dat = p->dat[i + j * 16];
                if (fReverseMode)       //ʾȡ
                    dat = ~dat;
            
                OledCache[(y+j) * 128 + (x+i)] = dat;
            }
        }
    }
}

////////////////////////////////////////
// ʾַ
// ڲ: x (ˮƽ 0~127)
//           y (ֱ 0~7)
//           s (ַ׵ַ)
// : 
////////////////////////////////////////
void OLED_DrawString(int x, int y, char *str, uint8_t rf)
{
	while (*str)                        //ַΪգѭ
	{
        if (*str > 0)                   //ݵĴСжַǺ֣
        {
            if (FontHeight == 8)
            {
                OLED_Char6x8(x, y, *str);
                x += 6;
            }
            else
            {
                OLED_Char8x16(x, y, *str);
                x += 8;
            }
            str++;
        }
        else
        {
            OLED_Char16x16(x, y, str);
            x += 16;
            str += 2;
        }
        
		if (x > 127)
        {
            x = 0;
            y += 2;
        }
	}       

    if (rf)
        OLED_Refresh();                 //ˢʾ
}

////////////////////////////////////////
// ꣬ʹx0Сx1
// ڲ: x0 (0)
//           x1 (1)
// : 
////////////////////////////////////////
void NormalXY(int *x0, int *x1)
{
    if (*x0 > *x1)
    {
        int x;
        
        x = *x0;
        *x0 = *x1;
        *x1 = x;
    }
}

////////////////////////////////////////
// һ
// ڲ: x (ˮƽ 0~127)
//           y (ֱ 0~63)
//           c (ʾַASCII)
// : 
////////////////////////////////////////
void OLED_DrawPoint(int x, int y, uint8_t rf)
{
    if (fReverseMode)
        OledCache[(y / 8) * 128 + x] &= ~(1 << (y % 8));
    else
        OledCache[(y / 8) * 128 + x] |= 1 << (y % 8);

    if (rf)
        OLED_Refresh();                 //ˢʾ
}

////////////////////////////////////////
// һ
// ڲ: x0 (ʼˮƽ 0~127)
//           y0 (ʼĴֱ 0~63)
//           x1 (ˮƽ 0~127)
//           y1 (Ĵֱ 0~63)
// : 
////////////////////////////////////////
void OLED_DrawLine(int x0, int y0, int x1, int y1, uint8_t rf)
{
    if (x0 == x1)                       //ֱֱ
    {
        NORMAL(y0, y1);
        
        while (y0 <= y1)
            OLED_DrawPoint(x0, y0++, 0);
    }
    else if (y0 == y1)                  //ˮƽֱ
    {
        NORMAL(x0, x1);
        
        while (x0 <= x1)
            OLED_DrawPoint(x0++, y0, 0);
    }
    else
    {
        float x, y;
        float dx, dy;
        int dm, i;
        int lx, ly;
        
        lx = ( x1 > x0 ) ? ( x1 - x0 ) : ( x0 - x1 );
        ly = ( y1 > y0 ) ? ( y1 - y0 ) : ( y0 - y1 );

        dm = (lx >= ly) ? lx : ly;

        dx = (float)(x1 - x0) / dm;     //ˮƽ
        dy = (float)(y1 - y0) / dm;     //㴹ֱ
        x = (float)x0 + 0.5;            //ʼֵ
        y = (float)y0 + 0.5;

        for (i = 0; i <= dm; i++)
        {
            OLED_DrawPoint(x, y, 0);
            x += dx;
            y += dy;
        }
    }

    if (rf)
        OLED_Refresh();                 //ˢʾ
}

////////////////////////////////////////
// 
// ڲ: x0 (Ͻŵˮƽ 0~127)
//           y0 (ϽŵĴֱ 0~63)
//           x1 (½ǵˮƽ 0~127)
//           y1 (½ǵĴֱ 0~63)
// : 
////////////////////////////////////////
void OLED_DrawBox(int x0, int y0, int x1, int y1, uint8_t rf)
{
    OLED_DrawLine(x0, y0, x0, y1, 0);
    OLED_DrawLine(x0, y0, x1, y0, 0);
    OLED_DrawLine(x1, y1, x0, y1, 0);
    OLED_DrawLine(x1, y1, x1, y0, 0);

    if (rf)
        OLED_Refresh();                 //ˢʾ
}

////////////////////////////////////////
// Բ (ʹBresenham㷨Բ)
// ڲ: x0 (Բĵˮƽ 0~127)
//           y0 (ԲĵĴֱ 0~63)
//           r  (Բİ뾶)
// : 
////////////////////////////////////////
void OLED_DrawCircle(int x0, int y0, int r, uint8_t rf)
{
    int x, y, d;
    
    x = 0;
    y = r;
    d = 3 - 2 * r;

    while (x <= y)
    {
        OLED_DrawPoint(x0 + x, y0 - y, 0);
        OLED_DrawPoint(x0 + y, y0 - x, 0);
        OLED_DrawPoint(x0 - x, y0 - y, 0);
        OLED_DrawPoint(x0 - y, y0 - x, 0);
        OLED_DrawPoint(x0 - x, y0 + y, 0);
        OLED_DrawPoint(x0 - y, y0 + x, 0);
        OLED_DrawPoint(x0 + x, y0 + y, 0);
        OLED_DrawPoint(x0 + y, y0 + x, 0);

        if (d < 0)
        {
            d += 4 * x + 6;
        }
        else
        {
            d += 4 * ( x - y ) + 10;
            y--;
        }
        x++;
    }

    if (rf)
        OLED_Refresh();                 //ˢʾ
}

////////////////////////////////////////
// 
// ڲ: x0 (Ͻŵˮƽ 0~127)
//           y0 (ϽŵĴֱ 0~63)
//           x1 (½ǵˮƽ 0~127)
//           y1 (½ǵĴֱ 0~63)
// : 
////////////////////////////////////////
void OLED_FillBox(int x0, int y0, int x1, int y1, uint8_t rf)
{
    NORMAL(x0, x1);
    
    while (x0 <= x1)
    {
        OLED_DrawLine(x0, y0, x0, y1, 0);
        x0++;
    }

    if (rf)
        OLED_Refresh();                 //ˢʾ
}

////////////////////////////////////////
// Բ (ʹBresenham㷨Բ)
// ڲ: x0 (Բĵˮƽ 0~127)
//           y0 (ԲĵĴֱ 0~63)
//           r  (Բİ뾶)
// : 
////////////////////////////////////////
void OLED_FillCircle(int x0, int y0, int r, uint8_t rf)
{
    int x, y, d;
    
    x = 0;
    y = r;
    d = 3 - 2 * r;

    while (x <= y)
    {
        OLED_DrawLine(x0 + x, y0 - y, x0 + x, y0 + y, 0);
        OLED_DrawLine(x0 + y, y0 - x, x0 + y, y0 + x, 0);
        OLED_DrawLine(x0 - x, y0 - y, x0 - x, y0 + y, 0);
        OLED_DrawLine(x0 - y, y0 - x, x0 - y, y0 + x, 0);

        if (d < 0)
        {
            d += 4 * x + 6;
        }
        else
        {
            d += 4 * ( x - y ) + 10;
            y--;
        }
        x++;
    }

    if (rf)
        OLED_Refresh();                 //ˢʾ
}

